use async_graphql::SimpleObject;

use crate::scalar::{Id, Time};

#[derive(Debug, SimpleObject, sqlx::FromRow)]
pub struct Rolle {
    /// Die ID einer Rolle
    pub id: Id,

    /// Zeit wann die Rolle erstellt wurde
    pub created_at: Time,

    /// Zeit wann die Rolle geändert wurde
    pub updated_at: Time,

    /// Der Name einer Rolle
    pub rollenname: String,

    pub gruppen: Vec<Gruppe>,
}

/// TODO: Migration in ein separates Modul
#[derive(Debug, SimpleObject, sqlx::Type)]
pub struct Gruppe {
    /// Die ID einer Gruppe
    pub id: Id,

    /// Zeit wann die Gruppe erstellt wurde
    pub created_at: Time,

    ///Zeit wann die Gruppe geändert wurde
    pub updated_at: Time,

    /// Der Name einer Gruppe
    pub gruppenname: String,
}
