use anyhow::Error;
use chrono::Utc;
use ulid::Ulid;

use super::Service;
use crate::domain::rolle::model::RolleCreateInput;
use crate::domain::rolle::{entity, model};

impl Service {
    pub async fn create_rolle(&self, input: RolleCreateInput) -> Result<model::Rolle, Error> {
        // let username_exists = self.check_username_exists(&self.db, &input.name).await?;
        // if username_exists {
        //     return Err(Error::UsernameAlreadyExists.into());
        // }

        let rolle_input = entity::Rolle {
            id: Ulid::new().into(),
            rollenname: input.rollenname,
            created_at: Utc::now(),
            updated_at: Utc::now(),
        };

        let created_id = self.repo.create_rolle(&self.db, &rolle_input).await?;
        let rolle = self.repo.find_rolle_by_id(&self.db, created_id).await?;
        Ok(rolle)
    }
}
