use async_graphql::{Context, FieldResult, Object};
use sqlx::postgres::PgPool;

use crate::{models::modell::Modell, scalar::Id};

#[derive(Default)]
pub struct ModellQuery {}

#[Object(extends)]
impl ModellQuery {
    async fn modell<'a>(&self, ctx: &'a Context<'_>, id: Id) -> FieldResult<Modell> {
        let pool = ctx.data::<PgPool>()?;
        let row = Modell::read_one(pool, &id).await?;
        Ok(row)
    }

    async fn modelle<'a>(&self, ctx: &'a Context<'_>) -> FieldResult<Vec<Modell>> {
        let pool = ctx.data::<PgPool>()?;
        let output = Modell::read_all(pool).await?;

        Ok(output)
    }
}
