use async_graphql::{Context, FieldResult, Object};
use log::debug;
use sqlx::postgres::PgPool;

use crate::models::rolle::Rolle;

#[derive(Default)]
pub struct RolleQuery {}

#[Object(extends)]
impl RolleQuery {
    // async fn rolle<'a>(&self, ctx: &'a Context<'_>, id: Id) -> FieldResult<Modell> {
    //     let pool = ctx.data::<PgPool>()?;
    //     let row = Modell::read_one(pool, &id).await?;
    //     Ok(row)
    // }

    async fn rollen<'a>(&self, ctx: &'a Context<'_>) -> FieldResult<Vec<Rolle>> {
        let pool = ctx.data::<PgPool>()?;

        let rollen = sqlx::query_as!(Rolle, "SELECT * FROM rollen")
            .fetch_all(pool)
            .await?;

        Ok(rollen)
    }
}
